// (c) Adafruit Industries / Limor Fried 2010. Released under MIT license.
#include <inttypes.h>
#include <stdlib.h>
#include <WProgram.h>

#include "HardwareSPI.h"
#include "HardwareTimer.h"


class HL1606stripPWM {
 private:
  // How many bits of color per LED for PWM?
  // if its set to 2 bits/LED that means 6 bit color (since there are 3 LEDs)
  // if its set to 3 bits/LED that equals 9 bit color
  // if its set to 4 bits/LED that equals 12 bit color
  // Setting this to be higher means the CPU works harder, at some point it will run out of CPU
  // and look weird or flash
  uint8_t PWMbits;


// ...but HL1606 cant take faster than 1.5MHz and they're kinda sucky chips which
// means that if you have one bad chip in your string that cant go faster than say 500 MHz
// then the entire strand will fail. Sometimes you're lucky and they're all good - try 16
// but don't be surprised if they fail at 1MHz
  uint8_t SPIspeed;

  void timerinit(void);
  void SPIinit(void);
  
  

 public:
  HL1606stripPWM(uint8_t n, HardwareSPI *s, HardwareTimer *t, uint8_t l);
  void begin(void);
  void setLEDcolorPWM(uint8_t n, uint8_t r, uint8_t g, uint8_t b);
  uint8_t numLEDs(void);

  void setSPIspeed(uint8_t s);
  uint8_t getSPIspeed();

  void setPWMbits(uint8_t b);
  uint8_t getPWMbits();
  
  void enable(void);
  void disable(void);
  

};
